"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const Configuration_1 = require("./Configuration");
const buffer_1 = require("buffer");
const stream_1 = require("stream");
const path = require("path");
const tsioc_1 = require("tsioc");
const util_1 = require("./util");
/**
 * Base Controller.
 *
 * @export
 * @class Controller
 */
class BaseController {
    view(viewName, model) {
        if (!this.context.render) {
            return Promise.reject('view engin middleware no configed!');
        }
        else {
            return this.context.render(viewName, model);
        }
    }
    file(file, contentType, fileDownloadName) {
        let defer = util_1.Defer.create();
        if (file instanceof String) {
            let confige = this.context.container.get(Configuration_1.Configuration);
            let filepath = path.join(confige.rootdir, file);
            if (fs_1.existsSync(filepath)) {
                fs_1.readFile(filepath, contentType || 'utf8', (err, data) => {
                    if (err) {
                        defer.reject(err);
                    }
                    else {
                        defer.resolve(new buffer_1.Buffer(data));
                    }
                });
            }
        }
        else if (file instanceof buffer_1.Buffer) {
            defer.resolve(file);
        }
        else if (file instanceof stream_1.Stream) {
            file.once('end', (data) => {
                defer.resolve(new buffer_1.Buffer(data));
            })
                .once('error', defer.reject);
        }
        return defer.promise;
    }
}
__decorate([
    tsioc_1.AutoWired(util_1.symbols.IContext),
    __metadata("design:type", Object)
], BaseController.prototype, "context", void 0);
exports.BaseController = BaseController;

//# sourceMappingURL=sourcemaps/BaseController.js.map
