"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsioc_1 = require("tsioc");
const NotFoundRoute_1 = require("./NotFoundRoute");
const util_1 = require("util");
/**
 * base route.
 *
 * @export
 * @class BaseRoute
 * @extends {Composite}
 * @implements {IRoute}
 */
class BaseRoute extends tsioc_1.Composite {
    constructor(route) {
        super(route);
        this.url = route.substr(0);
    }
    add(node) {
        // if (this.url.indexOf(node.url) === 0) {
        //     super.add(node);
        // } else if (node.url.indexOf(this.url) === 0) {
        //     let parent = this.parent;
        //     let child = this;
        //     if (parent) {
        //         node.parent = parent;
        //         parent.add(node);
        //     }
        //     child.parent = node;
        //     node.add(child);
        // } else {
        //     node.url = this.url + node.url;
        //     super.add(node);
        // }
        // return this;
        node.url = this.url + node.url;
        super.add(node);
        return this;
    }
    match(ctx) {
        let prefix = util_1.isString(ctx) ? ctx : ctx.url;
        let route = this.find((r) => {
            return r.url && prefix && prefix.indexOf(r.url) === 0;
        });
        return route;
    }
    empty() {
        return NotFoundRoute_1.notFoundRoute;
    }
}
exports.BaseRoute = BaseRoute;

//# sourceMappingURL=../sourcemaps/router/BaseRoute.js.map
